--statcorr.ex

include ..\basics.e

constant
-- define TEXT
TEXT = "Research Methods Knowledge Base: Descriptive Statistics",
SOURCE = "http://www.socialresearchmethods.net/kb/statcorr.php",

-- declare data

height = {68,71,62,75,58,60,67,68,71,69,68,67,63,62,60,63,65,67,63,61},
self_esteem = {4.1,4.6,3.8,4.4,3.2,3.1,3.8,4.1,4.3,3.7,3.5,3.2,3.7,3.3,3.4,4.0,4.1,3.8,3.4,3.6},
            
n = count(height)
Title(TEXT,SOURCE)

-- output results
puts(1,"Frequencies\n")
puts(1,"-----------\n\nHeight:\n\n")
printTree(frequency(height))
zeroiseRoot()
puts(1,"\n\nSelf-esteem (all values * 10):\n\n")
printTree(frequency(10*self_esteem))

puts(1,"\nDescriptive statistics\n")
puts(1,"----------------------\n")
printf(1,"Means are:\t%5.1f and \t%5.3f\n",{average(height),average(self_esteem)})
printf(1,"Sstandard deviations are:\t%7.5f and %8.6f\n",{sqrt((n * variance(height))/(n - 1)),
                                                        sqrt((n * variance(self_esteem))/(n - 1))})
printf(1,"Variances are:\t%7.4f and %8.6f\n",{(n * variance(height)/(n - 1)),
                                              (n * variance(self_esteem)/(n - 1))})
printf(1,"Minima are:\t%5.0f and \t%5.1f\n",{minimum(height),minimum(self_esteem)})
printf(1,"Maxima are:\t%5.0f and \t%5.1f\n",{maximum(height),maximum(self_esteem)})
printf(1,"Ranges are:\t%5.0f and \t%5.1f\n",{range(height),range(self_esteem)})

printf(1,"\nCorrelation between height and self-esteem is %4.2f\n\n",correlation(height,self_esteem))

puts(1,"\nCovariances\n")
puts(1,"-----------\n")
printf(1,"Variance of height is                   %8.3f\n",variance(height))
printf(1,"Variance of self-esteem is              %8.3f\n",variance(self_esteem))
printf(1,"Covariance of height and self-esteem is %8.3f\n",covariance(height,self_esteem))
printf(1,"Standardise covariance by SDs gives     %8.3f\n",(covariance(height,self_esteem)
                                                          /sqrt(variance(height)*variance(self_esteem))))
puts(1,"** Lo and behold: the correlation coefficient **\n\n")

Closure()