--Winer1.10.1.ex

include basics.e

constant
-- define TEXT
TEXT = "Testing hypotheses about the difference between two means\n"
     & "\"correlated\" observations - same source two observations\n"
     & "sometimes know as matched pairs"
     & " (e.g. before and after treatment)",
SOURCE = "Winer Table 1.10-1",
-- declare data
A = {3,8,4,6,9,2,12},
B = {6,14,8,4,16,7,19},
-- declare derived values
D = A - B,                 -- note utility of sequence manipulation
N = count(D),              -- same as length(d)
DF = N - 1,
SD2 = variance(D)*N/DF    -- sample estimate

-- output heading
Title(TEXT,SOURCE)

-- hypothesised difference between means
-- test difference
include get.e
constant
PROMPT = "\nTesting hypothesis that average(a) - average(b) = "
-- results
puts(1,PROMPT)

constant
DIFF1 = gets(0),
DIFF2 = value(DIFF1[1..$-1]),
T = (average(D)-DIFF2[2])/sqrt((SD2/N)),
-- value from printed tables
T6 = 2.447

-- Output results
puts(1,'\n' & repeat('-',length(PROMPT)) & '\n')
printf(1,"t is %f, with %d degrees of freedom.\n",{T,DF})

printf(1,"Lower critical t value (p=0.025) is %.3f\n",-T6)
printf(1,"Upper critical t value (p=0.975) is %+.3f\n",T6)

if T > T6 or T < -T6 then
    puts(1,"\nR")
else
    puts(1,"\nDo not r")
end if
puts(1,"eject hypothesis, using two-tailed test (p = 0.05)\n")
printf(1,"\nN.B. correlation coefficient is %.3f\n\n",correlation(A,B))

Closure()