--Winer1.12.1.ex

include basics.e

constant
-- define TEXT
TEXT = "Using a Winsorised t test\n"
     & " (three runs)",
SOURCE = "Winer Table 1.12-1",
-- declare data
X = {68,46,45,43,43,41,40,40,38,35,32,31,10},
T = 2.179,
T1 = 2.228,
T2 = 2.306,
H = count(X),
H1 = H - 2,
H2 = H - 4

function calc(sequence X,integer H,atom T)
    atom A
    A = sqrt((sumOfSquares(X) - sum(X)*average(X))/(count(X)*(count(X)-1)))
      * (count(X)-1)*T/(H-1)
    return {average(X) - A,
            average(X) + A
           }
end function

-- declare derived values
sequence Xmod1,Xmod2
Xmod1 = X
Xmod1[1] = Xmod1[2]
Xmod1[$] = Xmod1[$-1]
Xmod2 = X
Xmod2[1] = Xmod2[3]
Xmod2[2] = Xmod2[3]
Xmod2[$] = Xmod1[$-2]
Xmod2[$-1] = Xmod1[$-2]

-- output heading
Title(TEXT,SOURCE)


-- Output results
puts(1,"Confidence intervals\n\n")
sequence c
c = calc(X,H,T)
printf(1,"Raw data: %.2f to %.2f\n",{c[1],c[2]})
c = calc(Xmod1,H1,T1)
printf(1,"Ends winsorised: %.2f to %.2f\n",{c[1],c[2]})
c = calc(Xmod2,H2,T2)
printf(1,"Ends winsorised twice: %.2f to %.2f\n",{c[1],c[2]})

Closure()