-- Winer2.1.4.ex


include basics.e
include ../matrix.e

constant
-- define TEXT
TEXT = "Multivariate Regression\n"
     & "predict value 'y' for given matrix 'x'",
SOURCE = "Winer Table 2.1-4",

-- declare data
X = {{1,3,6},
     {1,5,1},
     {1,7,2},
     {1,7,10},
     {1,9,7},
     {1,9,10}   
    },
Y = {10,5,15,20,40,10},
-- derived values
X1 = transpose(X),
X1X = multiply(X1,X),
X1Y = multiply(X1,transpose(Y)),
B = multiply(inverse(X1X),X1Y),
SIGMAYHAT2 = multiply(transpose(B),X1Y),
SIGMAY2 = multiply({Y},transpose(Y)),
SSY = SIGMAY2[1][1] - sum(Y)*average(Y),
SSERROR = SIGMAY2[1][1] - SIGMAYHAT2[1][1]

-- output heading
Title(TEXT,SOURCE)

-- output results
puts(1,"Regression of Y on X.\n\n")
printf(1,"The regression coefficients are: %.3f; %.3f; %.3f\n\n",
       {B[1][1],B[2][1],B[3][1]})

printf(1,"r-squared = %.4f\n",1 - SSERROR/SSY)

Closure()