-- Winer3.2.1x.ex

include basics.e
include ..//F.e

constant
-- text
text = "One-way analysis of variance\n"
     & "Matched groups,\n"
     & "three classes each with 8 values."
     & "\nReworked for variance components."
     & "\n\nSee Section 3.17",
source = "Winer Table 3.2-1",
-- data
x = {3,5,2,4,8,4,3,9,4,4,3,8,7,4,2,5,6,7,8,6,7,9,10,9},
y = {1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3},
-- derived values
test = anova(x,y),
mserror = test[1][2]/test[2][2],
dferror = test[2][2],
m = dferror/(dferror-2),
mstotal = variance(x),
msgroups = mstotal - mserror,
umsgroups = msgroups/m

-- output heading
Title(text,source)

-- results
puts(1,"Variance breakdown\n")
printf(1,"Total:   %.3f\n",mstotal)
printf(1,"Error:   %.3f\n",mserror)
printf(1,"Methods: %.3f\n",msgroups)
puts(1,"\nIntraclass correlation")
printf(1,"\nBiassed estimate   = %.3f",msgroups/mstotal)
printf(1,"\nUnbiassed estimate = %.3f\n",umsgroups/(umsgroups+mserror))

Closure()
