-- basics.e

constant
-- define working values for screen output
WIDTH = 70,
HYPHENS = repeat('-',WIDTH)

-- function Centre
-- this function surrounds a text string with a character separator
--
-- Input parameters
-- sText      - the string to be centred
-- aDelimiter - the character used to prefix and postfix the text string
--
-- Return value
-- the string suitably "doctored"
--
function Centre(sequence sText,atom aDelimiter)
    integer iX,iY
    iX = floor((WIDTH - length(sText))/2)
    iY = WIDTH - iX - length(sText)
    return repeat(aDelimiter,iX) & sText & repeat(aDelimiter,iY)
end function

-- procedure Title
-- this procedure outputs a heading and a source reference
--
-- Input parameters
-- sHeading - the string to be used as a heading
-- sOrigin  - the string to be used to designate the source of the example
--
global procedure Title(sequence sHeading,sequence sOrigin)
    puts(1,HYPHENS 
         & '\n'
         & sHeading
         & '\n'
         & HYPHENS
         & '\n'
         & Centre(sOrigin,' ')
         & '\n'
         & HYPHENS 
         & '\n'
         & '\n')
end procedure

-- procedure Closure
-- this procedure outputs a prompt and waits for a user response
--
global procedure Closure()
    puts(1,Centre(" End ",'-') & "\n\n--Press ENTER to close window--")
    if getc(0) then end if
end procedure

include ..//stats.e
