--statt_t.ex

include basics.e
include ..//F.e

constant
-- define TEXT
TEXT = "Computation of the t Statistic, "
     & "assuming unequal variances\n"
     & "in the two samples.\n\n"
     & "The sign reflects whether the first mean is greater or less than \n"
     & "the second.",
SOURCE = "http://en.wikipedia.org/wiki/Student's_t-test#Worked_examples",

-- declare data
x1 = {30.02, 29.99, 30.11, 29.97, 30.01, 29.99},
x2 = {29.89, 29.93, 29.72, 29.98, 30.02, 29.98},

-- declare derived values
diff = average(x1) - average(x2),
n = count(x1),
s_x1 = variance(x1)/(n-1),
s_x2 = variance(x2)/(n-1),
denom = sqrt(s_x1 + s_x2),
DF = power((s_x1 + s_x2),2) * (n - 1)/(s_x1 * s_x1 + s_x2*s_x2)

-- output heading
Title(TEXT,SOURCE)

-- output results
printf(1,"t is %f, with %d degrees of freedom.\n",{diff/denom,DF})
printf(1,"Critical F value (p=0.05) is %.3f\n",f5[1][DF])
printf(1,"Critical F value (p=0.01) is %.3f\n\n",f1[1][DF])

Closure()
