-- temperatures.ex

include basics.e

constant
-- define TEXT
TEXT = "Computation of frequency distributions.",
SOURCE = "http://www.mnstate.edu/wasson/ed602lesson3.htm",

-- declare data
temps = {50,45,49,50,43,
         49,50,49,45,49,
         47,47,44,51,51,
         44,47,46,50,44,
         51,49,43,43,49,
         45,46,45,51,46
        },
-- declare derived value
freq = distribution(temps)

-- define counter for table
integer aggregate, val
aggregate = 0
val = freq[1]       
-- output heading
Title(TEXT,SOURCE)

-- output results
puts(1,"Maximum temperature values (Farenheit) over thirty successive days.\n\n")
puts(1,"Distribution table:\n" &
       "-------------------\n")
for i = 2 to length(freq) do
	printf(1,"Value: %d: frequency: %d\n",{val,freq[i]})
	val += 1
end for

-- reset table counters
val = freq[1]
aggregate = 0

puts(1,"\n\nCumulative frequency table:\n" &
       "-------------------\n")
for i = 2 to length(freq) do
	aggregate += freq[i]
	printf(1,"Value: %d: frequency: %2d\n",{val,aggregate})
	val += 1
end for

puts(1,'\n' & repeat('-',70))
-- second dataset
constant
temps50 = {57,39,52,52,43,
           50,53,42,58,55,
           58,50,53,50,49,
           45,49,51,44,54,
           49,57,55,59,45,
           50,45,51,54,58,
           53,49,52,51,41,
           52,40,44,49,45,
           43,47,47,43,51,
           55,55,46,54,41
          },
interval = 3,
-- declare derived value
freq50 = real_distribution(temps50,interval)
val = freq50[1]

-- output results
puts(1,"\n\nMaximum temperature values (Farenheit) over fifty successive days.\n\n")
puts(1,"Distribution table:\n" &
       "-------------------\n")
for i = 2 to length(freq50) do
	printf(1,"Value: %d-%d: frequency: %2d\n",{val,val+interval-1,freq50[i]})
	val += interval
end for

-- reset table counters
val = freq50[1]
aggregate = 0

puts(1,"\n\nCumulative frequency table:\n" &
       "-------------------\n")
for i = 2 to length(freq50) do
	aggregate += freq50[i]
	printf(1,"Value: %d-%d: frequency: %2d\n",{val,val+interval-1,aggregate})
	val += interval
end for

Closure()
