-- Winer3.2.1.ex

include basics.e
include ..//F.e

constant
-- define TEXT
TEXT = "One-way analysis of variance\n"
     & "Matched groups,\n"
     & "three classes each with 8 values",
SOURCE = "Winer Table 3.2-1",

-- declare data
X = {3,5,2,4,8,4,3,9,4,4,3,8,7,4,2,5,6,7,8,6,7,9,10,9},
Y = {1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3},

-- declare DERIVED VALUES
TEST = anova(X,Y),
MSMETHODS = TEST[1][1]/TEST[2][1],
DFMETHODS = TEST[2][1],
MSERROR = TEST[1][2]/TEST[2][2],
DFERROR = TEST[2][2]

-- output heading
Title(TEXT,SOURCE)

-- output results
puts(1,"Source of variation\t Sum of Squares\t Degree of freedom\t Mean Square\n")
printf(1,"Between methods\t\t\t %g\t\t %d\t\t\t\t\t%g\n",{TEST[1][1],DFMETHODS,MSMETHODS})
printf(1,"Experimental error\t\t %g\t\t\t%d\t\t\t\t\t %g\n",{TEST[1][2],DFERROR,MSERROR})
printf(1,"Total\t\t\t\t\t%g\t\t\t%d\n",{TEST[1][1]+TEST[1][2],count(X)-1})
printf(1,"\n\nF-test = %g, with %d,%d degrees of freedom",{MSMETHODS/MSERROR,DFMETHODS,DFERROR})
printf(1,"\nF(2,21) for p=0.05 is %g",f5[DFMETHODS][DFERROR])
printf(1,"\nF(2,21) for p=0.01 is %g\n",f1[DFMETHODS][DFERROR])

Closure()
